def _pad(input: Tensor,
    pad: List[int],
    mode: str="constant",
    value: float=0.) -> Tensor:
  _0 = "AssertionError: Padding length must be divisible by 2"
  _1 = "AssertionError: Padding length too large"
  _2 = "Padding mode \"{}\"\" doesn\'t take in value argument"
  _3 = __torch__.torch.nn.functional._pad_circular
  _4 = "Only 2D, 3D, 4D, 5D padding with non-constant padding are supported for now"
  _5 = uninitialized(Tensor)
  _6 = torch.eq(torch.remainder(torch.len(pad), 2), 0)
  if _6:
    pass
  else:
    ops.prim.RaiseException(_0)
  _7 = torch.le(torch.floordiv(torch.len(pad), 2), torch.dim(input))
  if _7:
    pass
  else:
    ops.prim.RaiseException(_1)
  if torch.eq(mode, "constant"):
    _9 = torch.constant_pad_nd(input, pad, value)
    _8 = _9
  else:
    if torch.eq(value, 0.):
      pass
    else:
      _10 = torch.add("AssertionError: ", torch.format(_2, mode))
      ops.prim.RaiseException(_10)
    if torch.eq(torch.len(pad), 2):
      if torch.eq(torch.dim(input), 2):
        _12 = True
      else:
        _12 = torch.eq(torch.dim(input), 3)
      _11 = _12
    else:
      _11 = False
    if _11:
      if torch.eq(mode, "reflect"):
        _15 = torch.reflection_pad1d(input, pad)
        _14 = _15
      else:
        if torch.eq(mode, "replicate"):
          _17 = torch.replication_pad1d(input, pad)
          _16 = _17
        else:
          if torch.eq(mode, "circular"):
            _18 = _3(input, pad, )
          else:
            ops.prim.RaiseException("")
            _18 = _5
          _16 = _18
        _14 = _16
      _13 = _14
    else:
      if torch.eq(torch.len(pad), 4):
        if torch.eq(torch.dim(input), 3):
          _20 = True
        else:
          _20 = torch.eq(torch.dim(input), 4)
        _19 = _20
      else:
        _19 = False
      if _19:
        if torch.eq(mode, "reflect"):
          _23 = torch.reflection_pad2d(input, pad)
          _22 = _23
        else:
          if torch.eq(mode, "replicate"):
            _25 = torch.replication_pad2d(input, pad)
            _24 = _25
          else:
            if torch.eq(mode, "circular"):
              _26 = _3(input, pad, )
            else:
              ops.prim.RaiseException("")
              _26 = _5
            _24 = _26
          _22 = _24
        _21 = _22
      else:
        if torch.eq(torch.len(pad), 6):
          if torch.eq(torch.dim(input), 4):
            _28 = True
          else:
            _29 = torch.eq(torch.dim(input), 5)
            _28 = _29
          _27 = _28
        else:
          _27 = False
        if _27:
          if torch.eq(mode, "reflect"):
            _32 = torch.reflection_pad3d(input, pad)
            _31 = _32
          else:
            if torch.eq(mode, "replicate"):
              _34 = torch.replication_pad3d(input, pad)
              _33 = _34
            else:
              _35 = torch.eq(mode, "circular")
              if _35:
                _36 = _3(input, pad, )
              else:
                ops.prim.RaiseException("")
                _36 = _5
              _33 = _36
            _31 = _33
          _30 = _31
        else:
          ops.prim.RaiseException(_4)
          _30 = _5
        _21 = _30
      _13 = _21
    _8 = _13
  return _8
def _pad_circular(input: Tensor,
    padding: List[int]) -> Tensor:
  _37 = "AssertionError: Padding value causes wrapping around more than once."
  _38 = "AssertionError: Negative padding value is resulting in an empty dimension."
  in_shape = torch.size(input)
  paddable_shape = torch.slice(in_shape, 2)
  ndim = torch.len(paddable_shape)
  _39 = [9223372036854775807, torch.len(paddable_shape)]
  for idx in range(ops.prim.min(_39)):
    size = paddable_shape[idx]
    _40 = torch.neg(torch.add(torch.mul(idx, 2), 1))
    if torch.le(padding[_40], size):
      pass
    else:
      ops.prim.RaiseException(_37)
    _41 = torch.neg(torch.add(torch.mul(idx, 2), 2))
    if torch.le(padding[_41], size):
      pass
    else:
      ops.prim.RaiseException(_37)
    _42 = torch.neg(torch.add(torch.mul(idx, 2), 1))
    _43 = padding[_42]
    _44 = torch.neg(torch.add(torch.mul(idx, 2), 2))
    _45 = torch.add(torch.add(_43, padding[_44]), size)
    if torch.ge(_45, 0):
      pass
    else:
      ops.prim.RaiseException(_38)
  out_shape = torch.slice(in_shape, None, 2)
  _46 = [9223372036854775807, torch.len(paddable_shape)]
  out_shape0 = out_shape
  for idx0 in range(ops.prim.min(_46)):
    size0 = paddable_shape[idx0]
    _47 = torch.neg(torch.add(torch.mul(idx0, 2), 1))
    _48 = torch.add(size0, padding[_47])
    _49 = torch.neg(torch.add(torch.mul(idx0, 2), 2))
    out_shape1 = torch.add_(out_shape0, [torch.add(_48, padding[_49])])
    out_shape0 = out_shape1
  out = torch.new_empty(input, out_shape0)
  if torch.eq(ndim, 1):
    out_d0 = ops.prim.max(padding[-2], 0)
    out_d1 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
    in_d0 = ops.prim.max(torch.neg(padding[-2]), 0)
    _50 = in_shape[2]
    _51 = ops.prim.max(torch.neg(padding[-1]), 0)
    in_d1 = torch.sub(_50, _51)
    _52 = torch.slice(input, -1, in_d0, in_d1)
    _53 = torch.slice(out, -1, out_d0, out_d1)
    _54 = torch.copy_(_53, _52)
  else:
    if torch.eq(ndim, 2):
      out_d00 = ops.prim.max(padding[-2], 0)
      out_d10 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
      out_h0 = ops.prim.max(padding[-4], 0)
      out_h1 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
      in_d00 = ops.prim.max(torch.neg(padding[-2]), 0)
      _55 = in_shape[2]
      _56 = ops.prim.max(torch.neg(padding[-1]), 0)
      in_d10 = torch.sub(_55, _56)
      in_h0 = ops.prim.max(torch.neg(padding[-4]), 0)
      _57 = in_shape[3]
      _58 = ops.prim.max(torch.neg(padding[-3]), 0)
      in_h1 = torch.sub(_57, _58)
      _59 = torch.slice(input, -2, in_d00, in_d10)
      _60 = torch.slice(_59, -1, in_h0, in_h1)
      _61 = torch.slice(out, -2, out_d00, out_d10)
      _62 = torch.slice(_61, -1, out_h0, out_h1)
      _63 = torch.copy_(_62, _60)
    else:
      if torch.eq(ndim, 3):
        out_d01 = ops.prim.max(padding[-2], 0)
        out_d11 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
        out_h00 = ops.prim.max(padding[-4], 0)
        out_h10 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
        out_w0 = ops.prim.max(padding[-6], 0)
        out_w1 = torch.sub(out_shape0[4], ops.prim.max(padding[-5], 0))
        in_d01 = ops.prim.max(torch.neg(padding[-2]), 0)
        _64 = in_shape[2]
        _65 = ops.prim.max(torch.neg(padding[-1]), 0)
        in_d11 = torch.sub(_64, _65)
        in_h00 = ops.prim.max(torch.neg(padding[-4]), 0)
        _66 = in_shape[3]
        _67 = ops.prim.max(torch.neg(padding[-3]), 0)
        in_h10 = torch.sub(_66, _67)
        in_w0 = ops.prim.max(torch.neg(padding[-6]), 0)
        _68 = in_shape[4]
        _69 = ops.prim.max(torch.neg(padding[-5]), 0)
        in_w1 = torch.sub(_68, _69)
        _70 = torch.slice(input, -3, in_d01, in_d11)
        _71 = torch.slice(_70, -2, in_h00, in_h10)
        _72 = torch.slice(_71, -1, in_w0, in_w1)
        _73 = torch.slice(out, -3, out_d01, out_d11)
        _74 = torch.slice(_73, -2, out_h00, out_h10)
        _75 = torch.slice(_74, -1, out_w0, out_w1)
        _76 = torch.copy_(_75, _72)
      else:
        pass
  if torch.gt(padding[-2], 0):
    _77 = torch.sub(out_shape0[2], padding[-2])
    i0 = torch.sub(_77, ops.prim.max(padding[-1], 0))
    i1 = torch.sub(out_shape0[2], ops.prim.max(padding[-1], 0))
    o1 = padding[-2]
    _78 = torch.slice(torch.slice(torch.slice(out), 1), 2, i0, i1)
    _79 = torch.slice(torch.slice(torch.slice(out), 1), 2, 0, o1)
    _80 = torch.copy_(_79, _78)
  else:
    pass
  if torch.gt(padding[-1], 0):
    i00 = ops.prim.max(padding[-2], 0)
    i10 = torch.add(ops.prim.max(padding[-2], 0), padding[-1])
    o0 = torch.sub(out_shape0[2], padding[-1])
    o10 = out_shape0[2]
    _81 = torch.slice(torch.slice(torch.slice(out), 1), 2, i00, i10)
    _82 = torch.slice(torch.slice(torch.slice(out), 1), 2, o0, o10)
    _83 = torch.copy_(_82, _81)
  else:
    pass
  if torch.gt(torch.len(padding), 2):
    if torch.gt(padding[-4], 0):
      _84 = torch.sub(out_shape0[3], padding[-4])
      i01 = torch.sub(_84, ops.prim.max(padding[-3], 0))
      i11 = torch.sub(out_shape0[3], ops.prim.max(padding[-3], 0))
      o11 = padding[-4]
      _85 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _86 = torch.slice(_85, 3, i01, i11)
      _87 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _88 = torch.copy_(torch.slice(_87, 3, 0, o11), _86)
    else:
      pass
    if torch.gt(padding[-3], 0):
      i02 = ops.prim.max(padding[-4], 0)
      i12 = torch.add(ops.prim.max(padding[-4], 0), padding[-3])
      o00 = torch.sub(out_shape0[3], padding[-3])
      o12 = out_shape0[3]
      _89 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _90 = torch.slice(_89, 3, i02, i12)
      _91 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _92 = torch.copy_(torch.slice(_91, 3, o00, o12), _90)
    else:
      pass
  else:
    pass
  if torch.gt(torch.len(padding), 4):
    if torch.gt(padding[-6], 0):
      _93 = torch.sub(out_shape0[4], padding[-6])
      i03 = torch.sub(_93, ops.prim.max(padding[-5], 0))
      i13 = torch.sub(out_shape0[4], ops.prim.max(padding[-5], 0))
      o13 = padding[-6]
      _94 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _95 = torch.slice(torch.slice(_94, 3), 4, i03, i13)
      _96 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _97 = torch.slice(torch.slice(_96, 3), 4, 0, o13)
      _98 = torch.copy_(_97, _95)
    else:
      pass
    if torch.gt(padding[-5], 0):
      i04 = ops.prim.max(padding[-6], 0)
      i14 = torch.add(ops.prim.max(padding[-6], 0), padding[-5])
      o01 = torch.sub(out_shape0[4], padding[-5])
      o14 = out_shape0[4]
      _99 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _100 = torch.slice(torch.slice(_99, 3), 4, i04, i14)
      _101 = torch.slice(torch.slice(torch.slice(out), 1), 2)
      _102 = torch.slice(torch.slice(_101, 3), 4, o01, o14)
      _103 = torch.copy_(_102, _100)
    else:
      pass
  else:
    pass
  return out
