class ReflectionPad1d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  padding : Final[Tuple[int, int]] = (2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ReflectionPad1d,
    input: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.functional._pad(input, [2, 2], "reflect", 0., )
    return _0
class ReplicationPad1d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  padding : Final[Tuple[int, int]] = (2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ReplicationPad1d,
    input: Tensor) -> Tensor:
    _1 = __torch__.torch.nn.functional._pad(input, [2, 2], "replicate", 0., )
    return _1
class ConstantPad1d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  value : Final[float] = 3.5
  padding : Final[Tuple[int, int]] = (2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ConstantPad1d,
    input: Tensor) -> Tensor:
    _2 = __torch__.torch.nn.functional._pad(input, [2, 2], "constant", 3.5, )
    return _2
class ReflectionPad2d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  padding : Final[Tuple[int, int, int, int]] = (2, 2, 2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ReflectionPad2d,
    input: Tensor) -> Tensor:
    _3 = __torch__.torch.nn.functional._pad(input, [2, 2, 2, 2], "reflect", 0., )
    return _3
class ReplicationPad2d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  padding : Final[Tuple[int, int, int, int]] = (2, 2, 2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ReplicationPad2d,
    input: Tensor) -> Tensor:
    _4 = __torch__.torch.nn.functional._pad(input, [2, 2, 2, 2], "replicate", 0., )
    return _4
class ZeroPad2d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  value : Final[float] = 0.
  padding : Final[Tuple[int, int, int, int]] = (2, 2, 2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ZeroPad2d,
    input: Tensor) -> Tensor:
    _5 = __torch__.torch.nn.functional._pad(input, [2, 2, 2, 2], "constant", 0., )
    return _5
class ConstantPad2d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  value : Final[float] = 3.5
  padding : Final[Tuple[int, int, int, int]] = (2, 2, 2, 2)
  def forward(self: __torch__.torch.nn.modules.padding.ConstantPad2d,
    input: Tensor) -> Tensor:
    _6 = __torch__.torch.nn.functional._pad(input, [2, 2, 2, 2], "constant", 3.5, )
    return _6
class ReflectionPad3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  padding : Final[Tuple[int, int, int, int, int, int]] = (1, 1, 1, 1, 1, 1)
  def forward(self: __torch__.torch.nn.modules.padding.ReflectionPad3d,
    input: Tensor) -> Tensor:
    _7 = __torch__.torch.nn.functional._pad(input, [1, 1, 1, 1, 1, 1], "reflect", 0., )
    return _7
class ReplicationPad3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  padding : Final[Tuple[int, int, int, int, int, int]] = (3, 3, 3, 3, 3, 3)
  def forward(self: __torch__.torch.nn.modules.padding.ReplicationPad3d,
    input: Tensor) -> Tensor:
    _8 = __torch__.torch.nn.functional._pad(input, [3, 3, 3, 3, 3, 3], "replicate", 0., )
    return _8
class ConstantPad3d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : NoneType
  value : Final[float] = 3.5
  padding : Final[Tuple[int, int, int, int, int, int]] = (3, 3, 3, 3, 3, 3)
  def forward(self: __torch__.torch.nn.modules.padding.ConstantPad3d,
    input: Tensor) -> Tensor:
    _9 = __torch__.torch.nn.functional._pad(input, [3, 3, 3, 3, 3, 3], "constant", 3.5, )
    return _9
